/***************************************************************************
* KlBot.java
*
* Copyright (c) 2008, kfmes & lindol All rights reserved.
* 
* kfmes(KIM Ga-hyeon, klchat@kfmes.com)

* Lindol(PARK Ju-Yeon, lindolsang@gmail.com) 
* 
* http://kldp.net/projects/klchat or http://klchat.kldp.net
* 
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the klChat nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL kfmes & lindol BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************/
package kfmes.klBot;

import java.io.FileNotFoundException;

import org.schwering.irc.lib.IRCConnection;

/**
 * @author kfmes
 * @version $Id: KlBot.java,v 1.4 2009/03/12 00:08:39 kfmes Exp $
 */
public class KlBot {
	IRCConnection ircConn = null;
	IRCClient irc= null;
	
	
	public KlBot() {
		LogUtil.setVerbose(LogUtil.verbLevelNormal);
		
		try {
			LogUtil.fileInit();
		} catch (FileNotFoundException e) {
			
			e.printStackTrace();
		}
	}
	
	private void setup(String server, int port, String nick) {
		ircConn = new IRCConnection(server, new int[] { port }, 
				null,nick , "klbot", "klBot" );
		ircConn.setEncoding("MS949");
		ircConn.setColors(true);
		ircConn.setName("klBot");
		try{
			ircConn.connect();

			irc = new IRCClient(ircConn);
		}catch (Exception e) {
			LogUtil.stackTrace(e);
		}
		
		
		
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		KlBot ircapp = new KlBot();
		ircapp.setup("7kr.hanirc.org", 8080, args[0]);
	}


}
