/***************************************************************************
* LogUtil.java
*
* Copyright (c) 2008, kfmes & lindol All rights reserved.
* 
* kfmes(KIM Ga-hyeon, klchat@kfmes.com)

* Lindol(PARK Ju-Yeon, lindolsang@gmail.com) 
* 
* http://kldp.net/projects/klchat or http://klchat.kldp.net
* 
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the klChat nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL kfmes & lindol BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************/
package kfmes.klBot;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

/**
 * @author kfmes(KIM Ga-Hyeon, kfmes@inpion.com)
 * @version $Id: LogUtil.java,v 1.2 2008/03/19 13:04:16 kfmes Exp $
 */
public class LogUtil {

	//private static boolean isVerbose = false;

	public static final int verbLevelQuite = 0;
	public static final int verbLevelErrout = 1;
	public static final int verbLevelNormal = 2;
	
	private static int verbLevel = verbLevelNormal;

	//public static InputStream in = System.in;
	public static PrintStream out = System.out;
	public static PrintStream err =System.err;
	public static PrintStream fout = null;
	
	public static String logFile = "./log.txt";
	
	public static void fileInit() throws FileNotFoundException{
		
		fout = new PrintStream(new FileOutputStream(logFile, true));
	
	}
	
	public static void setVerbose(int level){
		verbLevel = level;
	}
	
	public static void println(String message){
		if(verbLevel>=verbLevelNormal)
			out.println(message);
	}
	public static void print(String message){
		if(verbLevel>=verbLevelNormal)
			out.print(message);
	}
	public static void errPrintln(String message){
		if(verbLevel>=verbLevelErrout)
			err.println(message);
	}
	public static void errPrint(String message){
		if(verbLevel>=verbLevelErrout)
			err.println(message);
	}
	public static void setOutputStream(PrintStream stdout, PrintStream stderr){
		out = stdout;
		err = stderr;		
	}
	public static void fprintln(String message){
		if(verbLevel>=verbLevelNormal){
			fout.println("[" + DateUtil.toTextString() + "]" + message);
			fout.flush();
		}
	}
	

	public static void stackTrace(Exception e) {
		if(verbLevel>=verbLevelErrout){
			for(StackTraceElement ste : e.getStackTrace())
				out.println(ste);
		}
		
	}
	
}