/*******************************************************************************
 * ActionGroup.java
 * 
 * Copyright (c) 2008, kfmes & lindol All rights reserved.
 * 
 * kfmes(KIM Ga-hyeon, klchat@kfmes.com) Lindol(PARK Ju-Yeon,
 * lindolsang@gmail.com)
 * 
 * http://kldp.net/projects/klchat or http://klchat.kldp.net
 * 
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: *
 * Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer. * Redistributions in binary
 * form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided
 * with the distribution. * Neither the name of the klChat nor the names of its
 * contributors may be used to endorse or promote products derived from this
 * software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL kfmes & lindol BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
package kfmes.klChat;

import java.util.StringTokenizer;



/**
 * @author kfmes
 * @version $Id: ActionGroup.java,v 1.5 2008/01/04 19:18:08 kfmes Exp $
 */
public class ActionGroup {
	private IRCClient irc = null;
	private MainFrame frmMain = null;
	
	public ActionGroup(MainFrame frmmain, IRCClient irc) {
		this.irc = irc;
		this.frmMain = frmmain;
	}
	
	public void actionConnect(){
		irc.connect();
	}
	public void actionDisconnect() {
		irc.quit();
		
	}
	
	
	public void actionQuit(){
		//frmMain.sShell.dispose();
		
		irc.con.doQuit("Bye");
		if(!frmMain.display.isDisposed())
			frmMain.display.dispose();
		
	}
	public void actionJoin(String chan){
		TabItem tabitem = frmMain.newTab(chan);
		irc.con.doJoin(chan);
		
	}

	public void actionTyped(String text) {
		/*
		StringTokenizer tk = new StringTokenizer(text);
		String first = tk.nextToken();
		String next = tk.nextToken();

		 */
		
		if(text.startsWith("/")){ //command
			String line[] = text.split(" ");
			if(line[0].equalsIgnoreCase("/j") ||  line[0].equalsIgnoreCase("/join")){
				actionJoin(line[1]);
			}
		}
		else { //privmsg
			String chan = frmMain.getShowingTab();

			irc.con.doPrivmsg(chan, text);
			frmMain.tabMap.get(chan).output('<' + irc.con.getNick() + "> " + text);
			
		}

		
	}
	
	public void actionLeave(String chan){
		irc.con.doPart(chan);
		
		
	}
	
	public void actionTest(){
		System.err.println(frmMain.getShowingTab());
	}


}
