/***************************************************************************
 * MainFrame.java
 *
 * Copyright (c) 2007, kfmes & lindol All rights reserved.
 * 
 * kfmes(KIM Ga-hyeon, klchat@kfmes.com)

 * Lindol(PARK Ju-Yeon, lindolsang@gmail.com) 
 * 
 * http://kldp.net/projects/klchat or http://klchat.kldp.net
 * 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the klChat nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL kfmes & lindol BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************/
package kfmes.klChat;

import java.io.FileReader;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabFolder2Listener;
import org.eclipse.swt.custom.CTabFolderAdapter;
import org.eclipse.swt.custom.CTabFolderEvent;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;

/**
 * @author kfmes
 * @version $Id: MainFrame.java,v 1.8 2008/01/04 19:18:08 kfmes Exp $
 */
public final class MainFrame {

	private IRCClient irc = null;
	private ActionGroup action = null;
	
	protected Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	protected Display display = null;  //  @jve:decl-index=0:
	protected CTabFolder cTabFolder = null;
	private Text txt_input = null;
	private MenuBar menuBar = null;
	protected ArrayList<TabItem> tabList = new ArrayList<TabItem>();  //  @jve:decl-index=0:
	protected HashMap<String, TabItem> tabMap = new HashMap<String, TabItem>();
	protected Properties prop = new Properties();

	public MainFrame() {
		try{
			

			prop.load( new FileReader("conf.ini"));
		
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		irc = new IRCClient(this);
		action = new ActionGroup(this, irc);
		
		init();
		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
	
	private void init(){
		display = Display.getDefault();
		createSShell();
		menuBar = new MenuBar(this, action);
		menuBar.setMainMenu();
		
		sShell.open();
		
		
	}
	
	
	/**
	 * This method initializes cTabFolder	
	 *
	 */
	private void createCTabFolder() {
		GridData gridData1 = new GridData();
		gridData1.grabExcessVerticalSpace = true;
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.verticalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		cTabFolder = new CTabFolder(sShell, SWT.NORMAL);
		cTabFolder.addCTabFolder2Listener(new CTabFolder2Listener(){

			public void close(CTabFolderEvent event) {


				//Object i =  event.getSource();
				CTabItem i = (CTabItem) event.item;
				if(i.getText().equals("NETWORK")){
					event.doit =false;
					action.actionDisconnect();
					return;
				}
				action.actionLeave(i.getText());
				removeTab(i);
				

				System.out.println("closed " + i );
				
			}

			public void maximize(CTabFolderEvent event) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void minimize(CTabFolderEvent event) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void restore(CTabFolderEvent event) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void showList(CTabFolderEvent event) {
				// TODO 자동 생성된 메소드 스텁
				
			}
			
		});
		cTabFolder.setLayoutData(gridData1);
		
		/*
		//
		CTabItem titem = new CTabItem(cTabFolder, SWT.CLOSE);
		//Tab network = new Tab(cTabFolder, SWT.CLOSE);
		titem.setText("TEST");
		Tab network = new Tab(cTabFolder, SWT.BORDER);
		titem.setControl(network);
		
		new 
		TabItem 
		tabList.add(new TabItem(titem, network));
		tabMap.put("NETWORK", network);
		*/
		
		newTab("NETWORK");
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		/* Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments)
		 * for the correct SWT library path in order to run with the SWT dlls. 
		 * The dlls are located in the SWT plugin jar.  
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 *       installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		MainFrame thisClass = new MainFrame();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridLayout gridLayout2 = new GridLayout();
		gridLayout2.horizontalSpacing = 2;
		gridLayout2.marginWidth = 2;
		gridLayout2.marginHeight = 2;
		gridLayout2.verticalSpacing = 2;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.horizontalSpacing = 2;
		gridLayout.marginWidth = 2;
		gridLayout.marginHeight = 2;
		gridLayout.verticalSpacing = 2;
		sShell = new Shell();
		sShell.setText("klChat");
		sShell.setLayout(gridLayout2);
		sShell.setSize(new Point(455, 248));
		createCTabFolder();
		sShell.setLayout(gridLayout);
		sShell.setSize(new Point(392, 261));
		txt_input = new Text(sShell, SWT.BORDER);
		txt_input.setLayoutData(gridData);
		txt_input.addKeyListener(new KeyListener(){

			public void keyPressed(KeyEvent e) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void keyReleased(KeyEvent e) {
				if(e.keyCode==13){
					System.out.println("key released");
					action.actionTyped(txt_input.getText().trim());
					txt_input.setText("");
				}
			}
			
		});
		
		
		txt_input.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				System.out.println("data");
				action.actionTyped(txt_input.getText().trim());
				txt_input.setText("");
			}
		});
	}

	public TabItem newTab(String chan) {
		CTabItem ti = new CTabItem(cTabFolder, SWT.CLOSE);
		Tab tab = new Tab(cTabFolder, SWT.BORDER);
		ti.setText(chan);
		ti.setControl(tab);
		TabItem ret = new TabItem(ti, tab);
		tabList.add(ret);
		tabMap.put(chan, ret);
		return ret;
	}
	
	private void removeTab(CTabItem i){
		TabItem rTab = tabMap.get(i.getText());
		tabMap.remove(i.getText());
		tabList.remove(rTab);
	}
	
	public String getShowingTab(){
		return cTabFolder.getSelection().getText();
	}

}
