/***************************************************************************
* MenuBar.java
*
* Copyright (c) 2007, kfmes & lindol All rights reserved.
* 
* kfmes(KIM Ga-hyeon, klchat@kfmes.com)

* Lindol(PARK Ju-Yeon, lindolsang@gmail.com) 
* 
* http://kldp.net/projects/klchat or http://klchat.kldp.net
* 
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the klChat nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL kfmes & lindol BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************/
package kfmes.klChat;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Decorations;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

/**
 * @author kfmes
 * @version $Id: MenuBar.java,v 1.2 2007/12/31 13:59:14 kfmes Exp $
 */
public class MenuBar {
	private MainFrame frmmain = null;
	private ActionGroup action = null;
	public MenuBar(MainFrame frmmain, ActionGroup action) {
		this.frmmain = frmmain;
		this.action = action;		
	}
	
	public void setMainMenu(){
		Menu mainmenu = new Menu(frmmain.sShell, SWT.BAR);
		
		MenuItem m_file = new MenuItem(mainmenu, SWT.CASCADE);
	
		m_file.setText("&File");
		
		
		Menu m_sub_file = new Menu(m_file);
		MenuItem m_file_connt = new MenuItem(m_sub_file, SWT.PUSH);
		m_file_connt.setText("&Connect");
		m_file_connt.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void widgetSelected(SelectionEvent e) {
				action.actionConnect();
			}
			
		});
		
		MenuItem m_file_test = new MenuItem(m_sub_file, SWT.PUSH);
		m_file_test.setText("&testt");
		m_file_test.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void widgetSelected(SelectionEvent e) {
				action.actionTest();
			}
			
		});
		
		
		MenuItem m_file_exit = new MenuItem(m_sub_file, SWT.PUSH);
		m_file_exit.setText("&Quit");
		m_file_exit.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO 자동 생성된 메소드 스텁
				
			}

			public void widgetSelected(SelectionEvent e) {
				action.actionQuit();
			}
			
		});
		
		m_file.setMenu(m_sub_file);
		
		
		frmmain.sShell.setMenuBar(mainmenu);
		

	}


}
