/***************************************************************************
* IRCClient.java
*
* Copyright (c) 2007, kfmes & lindol All rights reserved.
* 
* kfmes(KIM Ga-hyeon, klchat@kfmes.com)

* Lindol(PARK Ju-Yeon, lindolsang@gmail.com) 
* 
* http://kldp.net/projects/klchat or http://klchat.kldp.net
* 
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the klChat nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL kfmes & lindol BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************/
package klchateclipse;


import org.schwering.irc.lib.IRCConnection;
import org.schwering.irc.lib.IRCConstants;
import org.schwering.irc.lib.IRCEventListener;
import org.schwering.irc.lib.IRCModeParser;
import org.schwering.irc.lib.IRCUser;

/**
 * @author kfmes
 * @version $Id: IRCClient.java,v 1.4 2008/03/01 06:11:33 kfmes Exp $
 */
public class IRCClient implements IRCEventListener{

	protected ViewPart frmMain = null;
	protected IRCConnection irc = null;
	
	
	public IRCClient(ViewPart frmMain) {
		this.frmMain = frmMain;
	}
	
	public void connect(){
		irc = new IRCConnection("iz4u.hanirc.org", new int[] {8080}, null,UserInfo.UserNick,UserInfo.UserName, UserInfo.UserRealname);
		
		irc.setEncoding("MS949");
		irc.addIRCEventListener(this);
		try{
			irc.connect();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	public void quit(){
		irc.doQuit();
	}

	public void onDisconnected() {
	}

	public void onError(String msg) {
	}

	public void onError(int num, String msg) {
	}

	public void onInvite(String chan, IRCUser user, String passiveNick) {
	}

	public void onJoin(String chan, IRCUser user) {
		TabItem tabItem = frmMain.tabMap.get(chan); 
		tabItem.output(user.getNick()+"("+user.getUsername()+"@" + user.getHost()+" has joined #" + chan);
		tabItem.tab.addUserList(user.getNick());
	}

	public void onKick(String chan, IRCUser user, String passiveNick, String msg) {
	}

	public void onMode(String chan, IRCUser user, IRCModeParser modeParser) {
	}

	public void onMode(IRCUser user, String passiveNick, String mode) {
	}

	public void onNick(IRCUser user, String newNick) {
		System.out.println("onNick : " + user.getNick() +" : "+newNick);
		for(int i = 0; i < frmMain.tabList.size(); i++){
			TabItem tabItem =frmMain.tabList.get(i);
			tabItem.tab.renameUserList(user.getNick(), newNick);
		}
		
	}

	public void onNotice(String target, IRCUser user, String msg) {
		frmMain.tabMap.get("NETWORK").output(msg);
		
	}

	public void onPart(String chan, IRCUser user, String msg) {
		TabItem tabItem = frmMain.tabMap.get(chan); 
		tabItem.output(user.getNick()+"("+user.getUsername()+"@"+user.getHost()+" has left #" + chan);
		tabItem.tab.removeUserList(user.getNick());
		
	}

	public void onPing(String ping) {
	}

	public void onPrivmsg(String target, IRCUser user, String msg) {
		frmMain.tabMap.get(target).output('<' + user.getNick() + "> " +msg);
		
	}

	public void onQuit(IRCUser user, String msg) {
	}

	public void onRegistered() {
	}

	public void onReply(int num, String value, String msg) {
		switch(num){
		case IRCConstants.RPL_NAMREPLY:
			String string = value.substring(value.indexOf("#"));
			TabItem tabItem = frmMain.tabMap.get(string);
			tabItem.tab.initUserList(msg);
			break;
			
		}
	}

	public void onTopic(String chan, IRCUser user, String topic) {
	}

	public void unknown(String prefix, String command, String middle, String trailing) {
	}
	
}
