/***************************************************************************
 *
 * Copyright (c) 2007, kfmes & lindol All rights reserved.
 * 
 * kfmes(KIM Ga-hyeon, klchat@kfmes.com)

 * Lindol(PARK Ju-Yeon, lindolsang@gmail.com) 
 * 
 * http://kldp.net/projects/klchat or http://klchat.kldp.net
 * 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the klChat nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY kfmes & lindol ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL kfmes & lindol BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **************************************************************************/
package klchateclipse;

import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.custom.StyledTextContent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.List;

/**
 * @author kfmes
 * @version $Id: Tab.java,v 1.3 2008/02/29 02:46:25 snowflowersss Exp $
 */
public class Tab extends Composite {

	private SashForm sashForm = null;
	private StyledText chatLog = null;
	private List userList = null;

	public Tab(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		gridLayout.verticalSpacing = 0;
		createSashForm();
		this.setLayout(gridLayout);
	}

	/**
	 * This method initializes sashForm	
	 *
	 */
	private void createSashForm() {
		
		GridData gridData3 = new GridData();
		gridData3.grabExcessVerticalSpace = true;
		gridData3.horizontalAlignment = GridData.FILL;
		gridData3.verticalAlignment = GridData.FILL;
		gridData3.grabExcessHorizontalSpace = true;
		sashForm = new SashForm(this, SWT.NONE);
		
		chatLog = new StyledText(sashForm, SWT.READ_ONLY| /*SWT.BORDER | */ SWT.V_SCROLL);
		chatLog.setWordWrap(true);
		userList = new List(sashForm, SWT.V_SCROLL);
		
		sashForm.setWeights(new int[]{80,20});
		sashForm.setLayoutData(gridData3);
	}
	
	private void autoscroll(){
		StyledTextContent doc = chatLog.getContent();
		int docLength = doc.getCharCount();
		if (docLength > 0) {
			chatLog.setCaretOffset(docLength);
			chatLog.showSelection();
		}
		
	}
	
	protected void output(String line){
		final String outline = "\n" + line; 
		
		chatLog.getDisplay().asyncExec(new Runnable(){
			public void run(){
				chatLog.append(outline);
				autoscroll();
			}
		});
	}
	
	//첨 채널 들어갈때
	public void initUserList(final String list){
		Display display = getDisplay();
		display.syncExec( 
				new Runnable() { 
					public void run(){ 
						String[] str = list.split(" ");
						userList.setItems(str);
					} 
				}
		);
	}
	public void addUserList(final String nick){
		Display display = getDisplay();
		display.syncExec( 
				new Runnable() { 
					public void run(){ 
						userList.add(nick);
					} 
				}
		);
	}
	public void removeUserList(final String nick){
		Display display = getDisplay();
		display.syncExec( 
				new Runnable() { 
					public void run(){ 
						for (int i = 0; i < userList.getItemCount(); i++) {
							if (nick.equals(userList.getItem(i))) {
								userList.remove(nick);
								return;
							} else if (("@" + nick).equals(userList.getItem(i))) {
								userList.remove(nick);
								return;
							}
						}
					} 
				}
		);
	}
	public void renameUserList(final String nick, final String newNick){
		Display display = getDisplay();
		display.syncExec( 
				new Runnable() { 
					public void run(){ 
						for (int i = 0; i < userList.getItemCount(); i++) {
							if (nick.equals(userList.getItem(i))) {
								userList.setItem(i, newNick);
								return;
							} else if (("@" + nick).equals(userList.getItem(i))) {
								userList.setItem(i, "@"+newNick);
								return;
							}
						}
					} 
				}
		);
	}

}
