package klchateclipse;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;


public class UserInfoDialog extends Dialog {

	private Text realNameText;
	private Text nameText;
	private Text nickText;

	public UserInfoDialog(Shell parentShell) {
		super(parentShell);
	}

	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		final GridLayout gridLayout = new GridLayout();
		gridLayout.marginRight = 10;
		gridLayout.marginLeft = 10;
		gridLayout.marginTop = 20;
		gridLayout.verticalSpacing = 15;
		gridLayout.numColumns = 2;
		container.setLayout(gridLayout);

		final Label userInfomationInputLabel = new Label(container, SWT.NONE);
		final GridData gd_userInfomationInputLabel = new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1);
		userInfomationInputLabel.setLayoutData(gd_userInfomationInputLabel);
		userInfomationInputLabel.setText("User Infomation Setting");

		final Label nickLabel = new Label(container, SWT.NONE);
		final GridData gd_nickLabel = new GridData(SWT.RIGHT, SWT.CENTER, false, false);
		nickLabel.setLayoutData(gd_nickLabel);
		nickLabel.setText("Nick : ");

		nickText = new Text(container, SWT.BORDER);
		final GridData gd_nickText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		nickText.setLayoutData(gd_nickText);

		final Label nameLabel = new Label(container, SWT.NONE);
		final GridData gd_nameLabel = new GridData(SWT.RIGHT, SWT.CENTER, false, false);
		nameLabel.setLayoutData(gd_nameLabel);
		nameLabel.setText("Name : ");

		nameText = new Text(container, SWT.BORDER);
		final GridData gd_nameText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		nameText.setLayoutData(gd_nameText);

		final Label realnameLabel = new Label(container, SWT.NONE);
		final GridData gd_realnameLabel = new GridData(SWT.RIGHT, SWT.CENTER, false, false);
		realnameLabel.setLayoutData(gd_realnameLabel);
		realnameLabel.setText("RealName : ");

		realNameText = new Text(container, SWT.BORDER);
		final GridData gd_realNameText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		realNameText.setLayoutData(gd_realNameText);

		
		nickText.setText(UserInfo.UserNick);
		nameText.setText(UserInfo.UserName);
		realNameText.setText(UserInfo.UserRealname);
		
		return container;
	}
	
	
	@Override
	protected void okPressed() {
		
		UserInfo.UserNick		= nickText.getText();
		UserInfo.UserName		= nameText.getText();
		UserInfo.UserRealname	= realNameText.getText();
		
		super.okPressed();
	}


	@Override
	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,true);
		createButton(parent, IDialogConstants.CANCEL_ID,IDialogConstants.CANCEL_LABEL, false);
	}



	@Override
	protected Point getInitialSize() {
		return new Point(400, 275);
	}

}
